libstdc++: std::stack< _Tp, _Sequence > Class Template Reference

libstdc++

std::stack< _Tp, _Sequence > Class Template Reference
Containers » Sequences

`#include <stl_stack.h>`

## Public Types
typedef _Sequence::const_reference | const_reference
typedef _Sequence | container_type
typedef _Sequence::reference | reference
typedef _Sequence::size_type | size_type
typedef _Sequence::value_type | value_type

## Public Member Functions
template<typename _Seq = _Sequence, typename _Requires = typename enable_if<is_default_constructible<_Seq>::value>::type>
| stack ()
template<typename _InputIterator, typename _Alloc, typename = _RequireInputIter<_InputIterator>, typename = _Uses<_Alloc>>
| stack (_InputIterator __first, _InputIterator __last, const _Alloc &__a)
| stack (_Sequence &&__c)
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>
| stack (_Sequence &&__c, const _Alloc &__a)
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>
| stack (const _Alloc &__a)
| stack (const _Sequence &__c)
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>
| stack (const _Sequence &__c, const _Alloc &__a)
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>
| stack (const stack &__q, const _Alloc &__a)
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>
| stack (stack &&__q, const _Alloc &__a)
template<typename... _Args>
decltype(auto) | emplace (_Args &&... __args)
bool | empty () const
void | pop ()
void | push (const value_type &__x)
void | push (value_type &&__x)
size_type | size () const
void | swap (stack &__s) noexcept(__is_nothrow_swappable< _Sequence >::value)
reference | top ()
const_reference | top () const

## Protected Attributes
_Sequence | c

## Friends
template<typename _Tp1, typename _Seq1>
bool | operator< (const stack< _Tp1, _Seq1 > &, const stack< _Tp1, _Seq1 > &)
template<typename _Tp1, three_way_comparable _Seq1>
compare_three_way_result_t< _Seq1 > | operator<=> (const stack< _Tp1, _Seq1 > &, const stack< _Tp1, _Seq1 > &)
template<typename _Tp1, typename _Seq1>
bool | operator== (const stack< _Tp1, _Seq1 > &, const stack< _Tp1, _Seq1 > &)

## Detailed Description

template<typename _Tp, typename _Sequence = deque<_Tp>>
class std::stack< _Tp, _Sequence >

A standard container giving FILO behavior.

Template Parameters

  _Tp | Type of element.
  _Sequence | Type of underlying sequence, defaults to deque<_Tp>.

Meets many of the requirements of a container, but does not define anything to do with iterators. Very few of the other standard container interfaces are defined.

This is not a true container, but an adaptor. It holds another container, and provides a wrapper interface to that container. The wrapper is what enforces strict first-in-last-out stack behavior.

The second template parameter defines the type of the underlying sequence/container. It defaults to std::deque, but it can be any type that supports `back`, `push_back`, and `pop_back`, such as std::list, std::vector, or an appropriate user-defined type.

Members not found in normal containers are `container_type`, which is a typedef for the second Sequence parameter, and `push`, `pop`, and `top`, which are standard stack/FILO operations.

Definition at line 107 of file stl_stack.h.

## Member Typedef Documentation

## ◆ const_reference

template<typename _Tp, typename _Sequence = deque<_Tp>>

typedef _Sequence::const_reference std::stack< _Tp, _Sequence >::const_reference

Definition at line 150 of file stl_stack.h.

## ◆ container_type

template<typename _Tp, typename _Sequence = deque<_Tp>>

typedef _Sequence std::stack< _Tp, _Sequence >::container_type

Definition at line 152 of file stl_stack.h.

## ◆ reference

template<typename _Tp, typename _Sequence = deque<_Tp>>

typedef _Sequence::reference std::stack< _Tp, _Sequence >::reference

Definition at line 149 of file stl_stack.h.

## ◆ size_type

template<typename _Tp, typename _Sequence = deque<_Tp>>

typedef _Sequence::size_type std::stack< _Tp, _Sequence >::size_type

Definition at line 151 of file stl_stack.h.

## ◆ value_type

template<typename _Tp, typename _Sequence = deque<_Tp>>

typedef _Sequence::value_type std::stack< _Tp, _Sequence >::value_type

Definition at line 148 of file stl_stack.h.

## Constructor & Destructor Documentation

## ◆ stack() [1/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>
template<typename _Seq = _Sequence, typename _Requires = typename enable_if<is_default_constructible<_Seq>::value>::type>

std::stack< _Tp, _Sequence >::stack | ( |  | ) |
| inline

Default constructor creates no elements.

Definition at line 170 of file stl_stack.h.

## ◆ stack() [2/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>

std::stack< _Tp, _Sequence >::stack | ( | const _Sequence & | __c | ) |
| inlineexplicit

Definition at line 174 of file stl_stack.h.

## ◆ stack() [3/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>

std::stack< _Tp, _Sequence >::stack | ( | _Sequence && | __c | ) |
| inlineexplicit

Definition at line 178 of file stl_stack.h.

## ◆ stack() [4/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>

std::stack< _Tp, _Sequence >::stack | ( | const _Alloc & | __a | ) |
| inlineexplicit

Definition at line 211 of file stl_stack.h.

## ◆ stack() [5/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>

std::stack< _Tp, _Sequence >::stack | ( | const _Sequence & | __c,
|  | const _Alloc & | __a )
| inline

Definition at line 215 of file stl_stack.h.

## ◆ stack() [6/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>

std::stack< _Tp, _Sequence >::stack | ( | _Sequence && | __c,
|  | const _Alloc & | __a )
| inline

Definition at line 219 of file stl_stack.h.

## ◆ stack() [7/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>

std::stack< _Tp, _Sequence >::stack | ( | const stack< _Tp, _Sequence > & | __q,
|  | const _Alloc & | __a )
| inline

Definition at line 223 of file stl_stack.h.

## ◆ stack() [8/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>
template<typename _Alloc, typename _Requires = _Uses<_Alloc>>

std::stack< _Tp, _Sequence >::stack | ( | stack< _Tp, _Sequence > && | __q,
|  | const _Alloc & | __a )
| inline

Definition at line 227 of file stl_stack.h.

## ◆ stack() [9/9]

template<typename _Tp, typename _Sequence = deque<_Tp>>
template<typename _InputIterator, typename _Alloc, typename = _RequireInputIter<_InputIterator>, typename = _Uses<_Alloc>>

std::stack< _Tp, _Sequence >::stack | ( | _InputIterator | __first,
|  | _InputIterator | __last,
|  | const _Alloc & | __a )
| inline

Definition at line 234 of file stl_stack.h.

## Member Function Documentation

## ◆ emplace()

template<typename _Tp, typename _Sequence = deque<_Tp>>
template<typename... _Args>

decltype(auto) std::stack< _Tp, _Sequence >::emplace | ( | _Args &&... | __args | ) |
| inline

Definition at line 297 of file stl_stack.h.

## ◆ empty()

template<typename _Tp, typename _Sequence = deque<_Tp>>

bool std::stack< _Tp, _Sequence >::empty | ( |  | ) | const
| inlinenodiscard

Returns true if the stack is empty.

Definition at line 243 of file stl_stack.h.

## ◆ pop()

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::stack< _Tp, _Sequence >::pop | ( |  | ) |
| inline

Removes first element.

This is a typical stack operation. It shrinks the stack by one. The time complexity of the operation depends on the underlying sequence.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop() is called.

Definition at line 331 of file stl_stack.h.

## ◆ push() [1/2]

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::stack< _Tp, _Sequence >::push | ( | const value_type & | __x | ) |
| inline

Add data to the top of the stack.

Parameters

  __x | Data to be added.

This is a typical stack operation. The function creates an element at the top of the stack and assigns the given data to it. The time complexity of the operation depends on the underlying sequence.

Definition at line 286 of file stl_stack.h.

## ◆ push() [2/2]

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::stack< _Tp, _Sequence >::push | ( | value_type && | __x | ) |
| inline

Definition at line 291 of file stl_stack.h.

## ◆ size()

template<typename _Tp, typename _Sequence = deque<_Tp>>

size_type std::stack< _Tp, _Sequence >::size | ( |  | ) | const
| inlinenodiscard

Returns the number of elements in the stack.

Definition at line 249 of file stl_stack.h.

## ◆ swap()

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::stack< _Tp, _Sequence >::swap | ( | stack< _Tp, _Sequence > & | __s | ) |
| inlinenoexcept

Definition at line 339 of file stl_stack.h.

## ◆ top() [1/2]

template<typename _Tp, typename _Sequence = deque<_Tp>>

reference std::stack< _Tp, _Sequence >::top | ( |  | ) |
| inlinenodiscard

Returns a read/write reference to the data at the first element of the stack.

Definition at line 258 of file stl_stack.h.

## ◆ top() [2/2]

template<typename _Tp, typename _Sequence = deque<_Tp>>

const_reference std::stack< _Tp, _Sequence >::top | ( |  | ) | const
| inlinenodiscard

Returns a read-only (constant) reference to the data at the first element of the stack.

Definition at line 270 of file stl_stack.h.

## Member Data Documentation

## ◆ c

template<typename _Tp, typename _Sequence = deque<_Tp>>

_Sequence std::stack< _Tp, _Sequence >::c
| protected

Definition at line 156 of file stl_stack.h.

The documentation for this class was generated from the following file:

- stl_stack.h